# Copyright 2021 The NetKet Authors - All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from .base import MetropolisRule

from .fixed import FixedRule
from .local import LocalRule
from .exchange import ExchangeRule
from .hamiltonian import HamiltonianRule
from .continuous_gaussian import GaussianRule
from .langevin import LangevinRule
from .tensor import tensorRule as TensorRule
from .multiple import multipleRules as MultipleRules

# numpy backend
from .local_numpy import LocalRuleNumpy
from .hamiltonian_numpy import HamiltonianRuleNumpy
from .custom_numpy import CustomRuleNumpy

from netket.utils import _hide_submodules

_hide_submodules(__name__)
